#ifndef VIEW3D_H
#define VIEW3D_H

#include <QGLWidget>
#include <QMatrix4x4>
#include "vec.h"

class Mesh;

class View3d : public QGLWidget
{
	Q_OBJECT
public:
	explicit View3d(QWidget *parent = 0);
	~View3d();
	
signals:
	
public slots:
	void load(const QString &filename);
	void save(const QString &filename) const;

protected:
	virtual void initializeGL();
	virtual void resizeGL(int w, int h);
	virtual void paintGL();
	void mouseMoveEvent(QMouseEvent *);
	void mousePressEvent(QMouseEvent *);

private:
	Mesh *mesh;
	Vec3 center;
	float radius;
	QMatrix4x4 mesh_mat;
	QPointF last_cursor_pos;
};

#endif // VIEW3D_H
